/**
 *  ReEmission.java : 
 */

import java.net.*;
import java.io.*;

public class ReEmission extends Thread
{


    int jump=1;
    int max_jump=9; // un paquet n'est pas envoye tout les max_jump
    static final String VERSION = "0.1";

    static final boolean DBG = true;

    static final double INFINITE = 9999999L;
    
    static String serviceName = "MultiCastS"; //default service

    static String serviceBroker = "http://140.77.15.124"; 
    int delay = 2000; // default delay (ms) between each sent packet
    int timeout = 1000; // default time out
    static boolean infiniteLoop = true;


    int proxyTANport = 5432; // default port
    int serverPort = 5432;   // default port

    int proto = TANet.UDP; // default protocol is TCP
    String destId = null;
    long seq=0; // numero de sequence du paquet manquant
    int nbrPingPackets = 0;
    String proxyTAN = "";

    byte [] srvNameinBytes;
    byte [] srcIdinBytes  ;   
    byte [] destIdinBytes ;   
    byte [] lastIdinBytes ;   
    byte [] proxyTANIdinBytes;

    int payloadSize = 4*1024; // default payload size (Bytes)
    byte [] payload ;
    String recepteurOriginal = ""; // contient l`ip du recepteur 
    int repair=0;
    
    //  recuperation de l'adresse local
    InetAddress localhost;

    TANet net;

    ReEmission(TANet net,int delay,int payloadSize,int nbrPingPackets,String destId, String recepteurOriginal,int repair, String proxyTAN,long seq )
    {
    this.net=net;
    this.delay=delay;
    this.payloadSize=payloadSize;
    this.nbrPingPackets=nbrPingPackets;
    this.destId=destId; 
    this.recepteurOriginal=recepteurOriginal;
    this.repair=repair;
    this.proxyTAN=proxyTAN;
    this.seq=seq;
    
    
    
    
    // recuperation de l'adresse locale
    try {
    		localhost= InetAddress.getLocalHost();
    } catch (UnknownHostException e) {
		System.err.println( e );
    }
    
    
    } 



    public int sendDataPackets()
    {
	// cache and init some data
	
	String sbsn = new String(serviceBroker + "/" + serviceName);
	srvNameinBytes    = sbsn.getBytes();
	srcIdinBytes      = net.srcId.getBytes();
	destIdinBytes     = destId.getBytes(); 
	//lastIdinBytes     = srcIdinBytes;
	proxyTANIdinBytes = proxyTAN.getBytes(); 
	
	//int t_cpt = 0, r_cpt=0, timeout_cpt=0;
	//double t, total=0;
	
	
	lastIdinBytes     = (localhost.getHostAddress()).getBytes();
	

	// -------- remplissage du payload -------------
	
	
	
	
	try {

	ByteArrayOutputStream baos = new ByteArrayOutputStream();
	DataOutputStream dos = new DataOutputStream( baos );
	
	byte [] destIdinBytes      = recepteurOriginal.getBytes();
	
 	// on ajoute le numero de sequence  
	dos.writeLong(seq);
		 
	// on ajoute le bit repair
	dos.writeInt(repair);
	
	// on ajoute la date
	dos.writeLong(System.currentTimeMillis());
	
	
	
	// on ajoute les datas 
	for(int i=20; i<payloadSize-20;i++) 
	  {
		dos.writeByte(73);
	  }
	
	
	payload=baos.toByteArray();
		System.out.println("ReEmission paquet de donnees "+seq+" vers "+recepteurOriginal+" source :"+ net.srcId+" en passant par "+proxyTAN);	  
	} catch (FileNotFoundException e ) { 
	    System.out.println("ReEmission = " + e ); 
	
	} catch (IOException e ) { 
	    System.err.println("ReEmission = " + e );
	    System.exit(0);
	}			     
	
	
	    try {

		net.makeANEPkt( srvNameinBytes, srcIdinBytes, 
				destIdinBytes, lastIdinBytes, 
				proxyTANIdinBytes, payload );
		net.sendANEPkt_next(InetAddress.getByName(proxyTAN));

	    } catch (IOException e) {
		System.err.println( "ReEmission : recvANEPkt() : " + e );

	    }

	return 0;
    } // sendDataPackets()



    public void run()
    {
	
	// and finally send nak packets
	sendDataPackets();
	net.close();
	 if(DBG) System.out.println("ReEmission : run() thread done.");
    } // run()
	

}

