/**
 *  Reception.java : 
 */

import java.net.*;
import java.io.*;
import java.util.*;
import java.lang.*;
public class Reception extends Thread
{

 // ------------- gestion timer thread -----------------
 
    Hashtable HashTimer = new Hashtable(); 
    // hashtable de thread de timer 
    Object OTimer;
    Timer timerThread ;
// -----------------------------------------------------
	
	
	
    //---- perte provoqu de paquet : un tous les jump_max 
    int jump=0;
    int jump_max=9999;
    		
	
    final boolean DBG = true;

    final double INFINITE = 9999999L;
    
    static String serviceName = "MultiCastS"; //default service
    
    

    static String serviceBroker = "http://140.77.15.124"; 
    int delay_Timer=2500; // delay avant envoi d'un nak
    int delay = 10; // default delay (ms) between each sent packet
    int timeout = 1000; // default time out
    boolean infiniteLoop = true;
    int proxyTANport = 5432; // default port
    int serverPort = 5432;   // default port

    int proto = TANet.UDP; // default protocol is TCP
    String destId = null;
    long seq=0; // numero de sequence du paquet manquant
    int nbrPingPackets = 0;
    String proxyTAN = "";

    String recepteurOriginaire = ""; // contient l`ip du recepteur 
    
    
    //----------------  gestion TL -------------------------------
    LinkedList TL = new LinkedList(); 
    // track list : gestion de la reception et de la perte de Data Packet

    long LastReceive=0; // dernier paquet recu
    long LastOrdered=0;   // dernier paquet ordonne recu
    //--------------------------------------------------------------
    
    
    byte [] srvNameinBytes;
    byte [] srcIdinBytes  ;   
    byte [] destIdinBytes ;   
    byte [] lastIdinBytes ;   
    byte [] proxyTANIdinBytes;

    int payloadSize = 4*1024; // default payload size (Bytes)
    
    byte[] payload = new byte[payloadSize];
    int repair=0;

    TANet net;

    Reception(TANet net,int delay,int payloadSize,int nbrPingPackets,String destId,String recepteurOriginaire,int repair, String proxyTAN )
    {
    this.net=net;
    this.delay=delay;
    this.payloadSize=payloadSize;
    this.nbrPingPackets=nbrPingPackets;
    this.destId=destId; 
    this.recepteurOriginaire=recepteurOriginaire;
    this.repair=repair;
    this.proxyTAN=proxyTAN;
    } 





    public int recvPackets()
    {
   
    
	// cache and init some data
	String sbsn = new String(serviceBroker + "/" + serviceName);
	srvNameinBytes    = sbsn.getBytes();
	srcIdinBytes      = net.srcId.getBytes();
	//destIdinBytes     = destId.getBytes(); 
	lastIdinBytes     = srcIdinBytes;
	proxyTANIdinBytes = proxyTAN.getBytes(); 

    	
	double t, total=0;
	int nbrPP = nbrPingPackets;
	double min = INFINITE , max = 0 ; // min, max round trip time
	
	

	byte []  RecepteurOriginaireBytes;
	
		
	if(nbrPingPackets != 0) infiniteLoop = false;


	
	while( infiniteLoop ) {


	
	    try {
		
		
		// reception de paquet 
		net.recvANEPkt();

	        ByteArrayInputStream bais = new ByteArrayInputStream(net.getANEPkt().payload);
	        DataInputStream dis = new DataInputStream( bais );
		


		if((net.getANEPkt().payload.length!= 20) && !(net.srcId.equals("127.0.0.1") ) ) {
		// on ne prend pas en compte les paquets envoys par lui mme !!!	
			//System.out.println(" PAQUET de DONNEES RECU ");
			
			//  lecture de l'entete
			seq=dis.readLong();
                	System.out.println("recu DP "+seq+" ["+LastOrdered+"|"+LastReceive+"]");
                	repair=dis.readInt();
                	

                	jump++;
                	if ((seq==jump_max)                 	
                	) {
                	seq-- ;
                	jump_max=jump_max+25;
                	System.out.println("perte de paquet volontaire !");
                	// en changeant le numero de paquet, on fait croire au 
                	// recepteur que ce paquet a dj t recu

                	}

                	
                	
                	//****************** gestion TL **********************
                	
                	
  
                	// --------------test si on a recu un paquet manquant---------
   			if (seq<=LastReceive) { 
                		if (seq==LastOrdered+1 ) { 
  System.out.println("on a recu le 1er paquet manquant ("+seq+") on supprime le 1er elmt de TL : ");
                			TL.removeFirst();
                			LastOrdered=seq;
                			
                			// -------- on stoppe le timer correspondant ----------
                			
                			
                			timerThread =(Timer) HashTimer.get((seq)+"");
                			//System.out.println("timer alive="+timerThread.isAlive());
                			if (timerThread.isAlive()) {
                				System.out.println("timer alive, on le detruit");
                				timerThread.Stopper();
                			}
                			
                			HashTimer.remove(""+seq);// on supprime l'entre dans hashtimer
                			// --------------------------------------------------------
                			
                			
                			while (TL.size()>0 && TL.getFirst()=="0") {
 						// on supprime les entre de TL pour que le 1er
 						// elmt soit un paquet perdu
                				TL.removeFirst();
                				LastOrdered++;
                			} //while                		
                		
                		} else if (seq>LastOrdered && TL.contains(seq+"")){
                		
 System.out.println("on a recu un paquet manquant, le "+seq+". on le met a sa place dans la TL : "+(seq-LastOrdered));
 
                			TL.add((int)(seq-LastOrdered),"0") ;
                			
                   			
                			
                			 // -------- on stoppe le timer correspondant ----------
               System.out.println("mise a jour hashTimer "+seq+"="+HashTimer.contains(seq+""));
                			timerThread =(Timer) HashTimer.get((seq)+"");
                	System.out.println("timer alive="+timerThread.isAlive());
                			if (timerThread.isAlive()) {
                				System.out.println("timer alive, on le detruit");
                				timerThread.Stopper();
                			}
                			HashTimer.remove(""+seq);// on supprime l'entre dans hashtimer
                			// --------------------------------------------------------
                		} else {
                			 System.out.println("seq="+seq+">LastOrdered"+LastOrdered + "DP deja recu, on l'ignore");	 
                		} 
                	} else {
                		// la TL 'est pas vide : il manque au - 1 paquet
         			// on ajoute un nouveau DP dans la TL 
         			//et eventuellement des timers sur le DP manquant
         			if (LastReceive==LastOrdered && LastOrdered+1==seq) {
         				//System.out.println("DP recu, aucune perte en vu");
         				LastReceive=seq;
         				LastOrdered=seq;
         			} else {
 					while ((LastReceive+1)!=seq) {
 					System.out.println("on ajoute un timer sur le DP "+(LastReceive+1));
 						TL.add("1") ;

 						 					
 						//---------- ajout de timer -----------
 				
 				
 				
 					 	Timer timerThread = new Timer
 					 		((LastReceive+1),delay_Timer, net,destId, 
 					 	recepteurOriginaire, proxyTAN);
						OTimer = (Timer) timerThread;
						System.out.println("on rempli la hashtimer "+(LastReceive+1));
						HashTimer.put(""+(LastReceive+1), OTimer);
     						// lancement
						timerThread.start();
	
 						//--------------------------------
 					
 						LastReceive++;
 						
 					}
 					
 					// on ajoute un nouveau DP dans la TL 
 					TL.add("0") ;
 					LastReceive++;
 					System.out.println("on note dans TL la reception du DP "+seq);

				}
                	}
                	
                	
                	//******** test de la perte d'un paquet ************
                	
                	
                	
		} else {
		//	System.out.println(" NAK RECU ");
		//  lecture de l'entete
			seq=dis.readLong();
                	System.out.println("RECU NAK "+seq);
                	RecepteurOriginaireBytes= new byte[12];
                	recepteurOriginaire="";
                	for(int i=0; i<12;i++) 
			{
                   	   RecepteurOriginaireBytes[i]=dis.readByte();              								    recepteurOriginaire=
                   	   recepteurOriginaire+(char)RecepteurOriginaireBytes[i];
			}
		//System.out.println("on va envoyer  un paquet de donnee a recepteurOriginaire="+recepteurOriginaire);
		
						ReEmission remis = new ReEmission(net,0,payloadSize,
			1,proxyTAN, recepteurOriginaire, 1, proxyTAN,seq);			
			remis.start(); // start thread	
			
		} // fin du if


		if(delay != 0) {
		    try { sleep( delay ); } 
		    catch (InterruptedException e) {
		   }
		}
	    } catch (BadANEPversionException e) {
		System.err.println( "Reception : recvANEPkt() = Received " +
				    "unsupported ANEP version exception : "
				    +e);
	    } catch (IOException e) {
		System.err.println( e );

	    } catch (InterruptedException e) {
		System.err.println("Reception : timeout : [>"+timeout+"]");
		
	    }
	} // while()
	return 0;
    } // recvPackets()


    public void run()
    {
	// Connect this thread to the closest proxyTAN
	// (given by arguments -tan hostname)

	// and finally send ping packets
	recvPackets();		
	net.close();
	 
    } // run()
	

}

