import java.lang.*;
import java.net.*;
import java.io.*;
import java.util.*;
import com.sun.multicast.reliable.transport.um.*;
import com.sun.multicast.util.*;
import com.sun.multicast.reliable.transport.InvalidMulticastAddressException;
import com.sun.multicast.reliable.transport.InvalidTransportProfileException;
import com.sun.multicast.reliable.transport.RMStatistics;
import inria.util.*;


public class Multicast_Sender extends Thread {

    File f=null;;
    ActiveSend as;// Pour envoyer les paquet de donnees
    
    FileInputStream in;
    int bytesread;
    int total_bytes_read=0;
    int n;
    byte pad;
    byte [] dat;


    static byte [] srvNameinBytes;
    static byte [] srcIdinBytes ;
    static byte [] recIdinBytes ;
    static String  recId;
    String serviceName;
    String serviceBrocker;
    String sbsn;

    int payloadSize ;
    byte [] payload ;
    byte [] buffer  ;
    ANEPacket anepacket;
    TANet net;
    DSCacheControl pkt;
    int  type;
    long seq;
    int repair ;
    long maxseq ;
    long rate ;
    long file_size;

    Unicast_Recv ur;
    StreamStruct stream;

    Send_Indicator si;
    
    
    public Multicast_Sender (String Multicast_address,  String sendFileName) throws 
    FileNotFoundException, UnknownHostException, UnknownHostException, SocketException, IOException
    {
     serviceName = "MulticastS"; 
     serviceBrocker = "http://140.77.15.124";
     sbsn = new String (serviceBrocker + "/" + serviceName);
     srvNameinBytes = sbsn.getBytes();

     InetAddress localhost;
     localhost = InetAddress.getLocalHost();	// adresse source
     srcIdinBytes = (localhost.getHostAddress()).getBytes();
     
     recId=Multicast_address;
     recIdinBytes=recId.getBytes();

     String logfile_name = "mSend.txt";
     File f2 = new File(logfile_name);

     f = new File(sendFileName);
     file_size = f.length();
     in = new FileInputStream(f);
     

     as = new ActiveSend ();
     as.init_socket(Multicast_address,4000);

     
     payloadSize = 4*1024;
     type= 0;
     seq = 0 ;
     repair = 0 ;
     maxseq = 0 ;
     
     bytesread = 0 ;
     n = 0;
    
     dat=new byte [1000];
     
     stream = new StreamStruct(f,true);// C une structure d emetteur
     
     si = new Send_Indicator (this);
     
     ur = new Unicast_Recv(null, stream);
     
     net = new TANet ();

}

   public void start ()
    { 
      ur.start();
      si.start();
      super.start();
    }


    public void run () 
    {  
	
    try {
	   try {
		   this.sleep(8000);
	       } catch (InterruptedException e){System.out.println (e);}
	
	
	while  ((bytesread=in.read(dat))!=-1) 
	     {
	       ByteArrayOutputStream baos = new ByteArrayOutputStream ();
	       DataOutputStream dos = new DataOutputStream (baos);
	       seq++;
	       total_bytes_read=total_bytes_read + bytesread;
	       
	       dos.writeInt(type);
	       dos.writeInt(repair);
	       dos.writeLong(seq);
	       dos.writeLong(maxseq);
	       dos.writeLong(rate);
	       dos.writeInt(bytesread);
	       dos.writeLong(file_size);
	     
	       for (int i=44;i<(bytesread+48);i++)
		   dos.write(80);
		

	      payload=baos.toByteArray();

	      for (int k=0; k<bytesread; k++ )
	      payload[k+44]= dat[k];
		 
	      net.makeANEPkt(srvNameinBytes,srcIdinBytes,recIdinBytes,recIdinBytes,recIdinBytes,payload);
	      anepacket = net.anepkt;
	      DCacheControl pkt= new DCacheControl(seq , anepacket);

	      
	      stream.dcache.addElement(pkt);

	      
	      byte []  buffer = new byte [4000];
	     	      
	      buffer = net.anepkt.marshall();
	      int size   = buffer.length;
	            
	      as.write(buffer,size);
           
	     
	      try {
		   this.sleep(100);
	       } catch (InterruptedException e){System.out.println (e);}
	     
	   }
	
	//System.out.println("Transfert termine");
	si.stop();
       }catch (IOException e){System.out.println (e);}
    
    
      
    }
    
}







