
import java.lang.*;
import java.net.*;
import java.io.*;
import java.util.*;
import com.sun.multicast.reliable.transport.um.*;

public class Source {

File f;
UMPacketSocket ms;
static byte [] srvName;
static byte [] srcId  ;
long maxseq;
long nextmaxseq;
long highPktSeqInCache;
FileOutputStream out ;
boolean cacheFull;
DVector dataSourceCache;
LOVector loVector;


   public Source (File f,File f2,UMPacketSocket ms,byte [] srvName,byte [] srcId) throws FileNotFoundException
    {
     this.f = f;
     this.out = new FileOutputStream (f2);
     this.ms= ms;
     this.srvName = srvName;
     this.srcId = srcId;
     this.maxseq = 1;
     this.nextmaxseq=1;
     this.highPktSeqInCache = 1;
     this.dataSourceCache = new DVector ();
     this.cacheFull = false;
     this.loVector  = new LOVector();
    }


    public void print(long seq) throws IOException
    {String message1 ="Le paquet ";
     String message2 = " est re-emis";
     String message = new String (message1+seq+message2+'\n');
     //String message  = new String (message3+\n+); 
     this.out.write(message.getBytes());
    }


    public long GetRate ()
    {
	return (ms.getDataRate()); 
    }	


    public void purgeCache(int lowWaterMark)

    {   DSCacheControl pkt;
        int i = 0 ;

	while (i<dataSourceCache.size())
	{ 
	  pkt =  (DSCacheControl) dataSourceCache.elementAt(i);
	  
	  if (pkt.seq>=maxseq)
	      {dataSourceCache.removeElementAt(i);
	       
	       if (dataSourceCache.size()<=lowWaterMark)
	        break;
	       
	       i=0;
	      }
	}
    }


    public void addLo(long lo, String srcId)
    {
	LOCacheControl loCacheControl;

	if (loVector.isEmpty())
	{loCacheControl = new LOCacheControl (lo,srcId);
	 loVector.addElement(loCacheControl);
	} 
	else
	{   int i=0;
	    while (i<loVector.size())
	    { loCacheControl = (LOCacheControl) loVector.elementAt(i);
	      if (loCacheControl.srcId.equals(srcId))
		  { 
		    if (lo>loCacheControl.lo)
		    loCacheControl.lo=lo;
		    //System.out.println("un lo mis a jours");
		    
		   break;
		  }
	       i++;
	     }
		        
	    if (i==loVector.size())
	    {loCacheControl = new LOCacheControl (lo,srcId);
	     loVector.addElement(loCacheControl);
	    } 
	}    
    }


}






