import java.lang.*;
import java.net.*;
import java.io.*;
import java.util.*;

public class Update_Timer extends Thread {

DStream dataStream;

  public Update_Timer (DStream dataStream)
   {
     this.dataStream = dataStream;
   }

  public void run ()  
   { 
	while (this.isAlive())
	 { 
	     int req_dup_count = dataStream.req_dup_count;
	     int rep_dup_count = dataStream.rep_dup_count;

             if ((req_dup_count>0)&&(rep_dup_count>0))
             { double facteur = req_dup_count/rep_dup_count;
	      dataStream.timer =  (int)(dataStream.timer*facteur);  
	      int timer = (dataStream.timer*10);
	      System.out.println("Le timer est mis a jour = "+timer);
	     }

	     dataStream.req_dup_count = 0;
	     dataStream.rep_dup_count = 0;
	     
            try {
               this.sleep(1000);
	      } catch (InterruptedException e){System.out.println (e);}
         }
   }

}

