import java.io.*;
import java.net.*;
import java.lang.*;
import java.util.*;
import com.sun.multicast.reliable.transport.um.*;
import com.sun.multicast.util.*;
import com.sun.multicast.reliable.transport.InvalidMulticastAddressException;
import com.sun.multicast.reliable.transport.InvalidTransportProfileException;
import com.sun.multicast.reliable.transport.RMStatistics;
import inria.util.*;

class Multicast_Sniffer extends Thread{

Hashtable NS = new Hashtable();
Hashtable TS = new Hashtable();


static final int MAX_SIZE = 4000;
static byte[] payload = new byte[MAX_SIZE];
static int port   = 4000; //12345;
static String interfaceName = null;
static DatagramSocket ds;
static DatagramSocket ds2;
int type;
long seq;
long next=1;
TANet net;
ActiveSend as ;
Init_session is;
String Multicast_Address = null;
InetAddress multicast_address;
MulticastSocket ms;
String srcId = null;
Unicast_Sniffer us;


    public Multicast_Sniffer (Unicast_Sniffer us) throws SocketException,IOException
  {   net = new TANet ();
      as = new ActiveSend();
      ds = new DatagramSocket( port );
      ds.setSoTimeout(8000);
      this.us=us;
  }


 public void dataPktHandler(byte [] buffer, int size, long seq) throws IOException, 
                                                                 UnknownHostException
  { 
      
  
      if (seq>next)
       {
	   for (long i=next;i<seq;i++)
	   lostHandler(i);    
       }

      if (seq==1)
      ds.setSoTimeout(750);

      next=seq+1;


      as.write(buffer,size);
           

   }

 public void  Init_Req() throws UnknownHostException, IOException, BadANEPversionException
  { 
    byte [] payload ;
    int type = 3;
    ANEPacket anepacket;
    
    InetAddress localhost;
    localhost = InetAddress.getLocalHost();
    String srcId = localhost.getHostAddress();
    byte [] srcIdinBytes = srcId.getBytes ();

    byte [] desIdinBytes = Multicast_Address.getBytes ();
	
    String serviceName = "MulticastS"; // Nom  du Sercive Multicast
    String serviceBrocker = "http://140.77.15.124";
    String sbsn = new String (serviceBrocker + "/" + serviceName);
    byte [] srvNameinBytes = sbsn.getBytes();

    ByteArrayOutputStream baos = new ByteArrayOutputStream ();
    DataOutputStream dos = new DataOutputStream (baos);	 
    dos.writeInt(type);
    payload=baos.toByteArray();

    TANet net = new TANet ();
    net.makeANEPkt(srvNameinBytes,srcIdinBytes,desIdinBytes,desIdinBytes,desIdinBytes,payload);
    anepacket = net.anepkt;
    byte []  buffer  = new byte [4000];
    
    buffer = anepacket.marshall();
    
    as.write(buffer,buffer.length);

  }  


 public void Init_Resp (String recId) throws IOException, BadANEPversionException 
    { 
      byte [] payload ;
      int type = 3;
      ANEPacket anepacket;
    
      InetAddress localhost;
      localhost = InetAddress.getLocalHost();
      String srcId = localhost.getHostAddress();
      byte [] srcIdinBytes = srcId.getBytes ();

      byte [] desIdinBytes = recId.getBytes ();

      String serviceName = "MulticastS"; // Nom  du Sercive Multicast
      String serviceBrocker = "http://140.77.15.124";
      String sbsn = new String (serviceBrocker + "/" + serviceName);
      byte [] srvNameinBytes = sbsn.getBytes();

      ByteArrayOutputStream baos = new ByteArrayOutputStream ();
      DataOutputStream dos = new DataOutputStream (baos);	 
      dos.writeInt(type);
      payload=baos.toByteArray();

      TANet net = new TANet ();
      net.makeANEPkt(srvNameinBytes,srcIdinBytes,desIdinBytes,desIdinBytes,desIdinBytes,payload);
      anepacket = net.anepkt;
      byte []  buffer = new byte [4000];
      buffer = anepacket.marshall();

      DatagramPacket dp = new DatagramPacket(buffer,buffer.length,InetAddress.getByName(recId),5000);
      ds2.send(dp);
    }

  public void lostHandler(long i)
    { 
       if(i==1)
	  { try
	       { ds.setSoTimeout(750);
	        } catch (SocketException se){System.out.println(se);}
          }

	NackCache nc = new NackCache (i);
	TS.put(Long.toString(i),nc);
	LinkedList LL= new LinkedList();
	Recepteur recepteur = new Recepteur ();
        recepteur.RecepteurOriginaire = us.srcId;
	recepteur.lo = 0;
	recepteur.lr = 0;
	recepteur.maxseq = 0;
	LL.add(recepteur);
	us.NS.put(Long.toString(i),LL);
		      
	try
	{us.usend.SendNack(srcId,i,0,0,0);
	}catch (UnknownHostException ue){System.out.println(ue);
	  }catch (IOException ie) {System.out.println(ie);}
		          
	System.out.println("Le paquet "+i+" est perdue");
    }


  
  public void run()
  {  
    try{
         while((this.isAlive())&&(us.session_end==false))
	  {  
	     DatagramPacket dp = new DatagramPacket (payload, MAX_SIZE);
	     ANEPacket anepkt;
	     
	     try
	     {
		 ds.receive (dp);
	       
	     }catch (SocketTimeoutException e){lostHandler(next);}
		     
	      byte [] buffer = dp.getData();
	      int size = dp.getLength();
	      
	      anepkt=ANEPacket.unmarshall(buffer);
	      
	      net.anepkt=anepkt;
	      net.recoverInfoFromANEPkt ();	   

	      	     
	      if (Multicast_Address==null)
		{ Multicast_Address = net.destId;
		  as.init_socket(Multicast_Address,4000);
		  
		}

	     if (srcId==null)
	     srcId=net.srcId;
	      
		
	     ByteArrayInputStream bais = new ByteArrayInputStream(anepkt.payload);
	     DataInputStream dis = new DataInputStream( bais );
	     type = dis.readInt();

	     if (type==0)
		{
		 //C un paquet de donnee
		 int repair = dis.readInt();
		 //seq=dis.readLong();
	         //dataPktHandler(buffer, size, seq);
		 as.write(buffer,size);
		}

	     if (type==3)
		{ is = new Init_session (net.destId);
		  is.Init_Req(); 
		  Init_Resp (net.srcId);
	       }

	   }
         }catch (IOException e) {System.out.println(e);
	   }catch (BadANEPversionException e){System.out.println(e);}
      }

}






















