/**
 *  MultiCastS.java
 *
 * 
 */


import java.io.*;
import java.net.*;
import java.util.*;
import java.lang.Object;

class MultiCastS extends Service 
{

    // ------------  affichage -------------------------
    
    final static boolean DBG =true;
    //= true <=> tous les affichages sauf les temps
    
    final static boolean TMP = false; 
    //= true <=> tous les temps d'execution des services  

    final static boolean RPY = false; 
    //= true <=>  les temps d'election replyer 
 
     final static boolean MOY = false; 
    //= true <=> affiche les moyennes tous les maxNbMOY, maxNbMOYDPR et maxNbMOYNak affichages  
    
    int maxNbMOY = 20;   
    int nbMOY=1 ; // compteur d'affichage des DP
    int maxNbMOYDPR = 20;   
    int nbMOYDPR=1 ; // compteur d'affichage des DPR    
    int maxNbMOYNak = 20;   
    int nbMOYNak=1 ; // compteur d'affichage des Nak


    
    // appel de TimerC : code C retournant le temps maxhine en microsec 
    
     static {
             System.loadLibrary("TimerC");
         }

 
    //************* gestion arbre multicast **************   
    int i=0;
    int max_multicast=4; // nombre d'entree dans le tableau multicastArb;
 
    String [][] MulticastArb={
    
    
    // node Tamanoir , destination DP
    
    //ike 		 , 	resamo
    {"140.77.15.12"  ,  "140.77.15.20"},   
    
    //resamo         ,  resamd & resama
    {"140.77.15.20"  ,  "140.77.15.18"},
    {"140.77.15.20"  ,  "140.77.15.99"},
    
    //resamd         ,   resamc
    {"140.77.15.18"  ,  "140.77.15.19"}




    // 6 faux recepteurs pour resamo 
    // ,{"140.77.15.20"  ,  "140.77.15.119"},

    // ,{"140.77.15.20"  ,  "140.77.15.120"},

    // ,{"140.77.15.20"  ,  "140.77.15.121"},

    // ,{"140.77.15.20"  ,  "140.77.15.122"},

    // ,{"140.77.15.20"  ,  "140.77.15.123"},

    // ,{"140.77.15.20"  ,  "140.77.15.124"},

    
    };

     // int max_fake_multicast=10; nombre total d'entre dans le tableau des
     // recepteurs comprenant (max_fake_multicast - max_multicast) faux
     // rcepteurs, qui seront parcourus UNIQUEMENT au moment de la recherche
     // d'un r-metteur (experience 5) 


    // emetteur : 
    String Emetteur;

    String DestinataireNak; 


    //  ********  gestion de la perte provoque de paquets ********
    int moyennePertePaquet =64000; 
    // un paquet est perdu tous les moyennePertePaquet
     double max_jump=Math.round((Math.random()*moyennePertePaquet))+64000; 
    // un paquet n'est pas envoye tout les max_jump

   
    
    
    
    
    //  ************ gestion des timers *****************    
    
    int delayTimer= 1100 ; 
    // temps d'attente entre chaque (re)emission de nak par les timers grant la TL
    
    int firstDelayNS = 900 ; 
    // temps d'attente avant d'mettre le 1er Nak par les timers grs par NS
    
    
    int firstDelayTL = 800 ; 
    // temps d'attente avant d'mettre le 1er Nak par les timers grs par TL   
    
    int delayTimerNS = 2000 ; 
    // temps d'attente entre chaque (re)emission de nak par les timers grant la NS
    // on prend un temps plus grand que le prcdant afin de traiter prioritairement
    // les pertes de paquets venant de la source  
    
    long delayTimerDecale;
    // dans la TL, lorsqu'on pert plusieurs DP de suite, on emet des Naks avec 
    // des delais diffrents, calculs  partir de leur numro de squence  
    
    // --------- timers pour le calcul du temps d'execution du service -------
    long temps; // recup de l'heure en microsec
    long tempsGestDP=0;  // temps de gestion d'un DP
    long tempsGestDPR=0; // temps de gestion d'un DPR
    long tempsGestNak=0;  // temps de gestion d'un NAK 
    
    
    long MoyenTempsGestDP=0; //moyenne du temps de gestion d'1 DP
    long NbTempsGestDP=0;    // nb de DP grs
    
    long MoyenTempsGestDPR=0;//moyenne du temps de gestion d'1 DPR
    long NbTempsGestDPR=0;// nb de DPR grs
        
    long MoyenTempsGestNak=0;//moyenne du temps de gestion d'1 nak
    long NbTempsGestNak=0;  // nb de nak grs
        
        
    long tempsTimerNK=0; //calcul du temps de lancement d'un thread timer
    // durant la getion d'un nak
 
    long tempsTimerDP=0;//calcul du temps de lancement d'un thread timer
    // durant la getion d'un DP
    
    int jump=1;
    long nbboucle=0;
     
    //****************  gestion TL **********************
    LinkedList TL = new LinkedList(); 
    // track list : gestion de la reception et de la perte de DP
    long LastReceive=0; // dernier paquet recu
    long LastOrdered=0;   // dernier paquet ordonne recu
    //*****************************************************
 
    
    
    InetAddress localhost; // contient l'adresse local

    

    
    
  //************** gestion  NS *************************
    
      final static Hashtable NS = new Hashtable();
      
      Object o;

 // *************** gestion timer thread ***************
 
    Hashtable HashTimer = new Hashtable(); 
    // hashtable de thread de timer 
    Object OTimer;
    TimerMCast timerThread ;
// *****************************************************
    
    MultiCastS() 
    {
	if(DBG) System.out.println( "MultiCastS : Service build " );
    }

    public void run()
    {
   

	
	
	
	long seq=0;
	int repair=0;
	int j=0;
	String recepteurOriginaire="";
	byte []  RecepteurOriginaireBytes;
	
	
	// -------  recuperation de l'adresse locale  ---------- 
	try {
    		localhost= InetAddress.getLocalHost();
    	} catch (UnknownHostException e) {
		System.err.println( e );
    	}
	
	// ----- rcupration de l'metteur de ce noeud tamanoir ----
	i=0;
	while (!(MulticastArb[i][1]).equals(localhost.getHostAddress())) {
		i++;
	}
    	Emetteur=MulticastArb[i][0];
	
	
	
	LinkedList LL = new LinkedList(); 
	// linked list intermediaire composant la table de hashage NS
	// compose des adresses IP ayant envoy un nak pour 
	// un paquet dont le numro de squence est la cl de la table NS
	


	try {
	
	
	    while(!FINISHED) {
	     

	     	    // ====== gestion des statististiques de dcompte du temps ======
	           // recuperation du temps en microsec par le lancement de TimeC.c
	           temps = new TimeC().TempsSys();
	     
	     
	     
	           ByteArrayInputStream bais = new
	             ByteArrayInputStream(net.getANEPkt().payload);
    	           DataInputStream dis = new DataInputStream( bais );	
    

		
		   //	if (TMP) System.out.println("aprs alloc Distr "+(new TimeC().TempsSys()-temps));	
		
   		     if (DBG) System.out.println("["+LastOrdered+"]["+LastReceive+"]"
   		   +" taille NS="+NS.size());
		
		
		  if (net.getANEPkt().payload.length>20)  {

		  
		  //==================================================
		  
		  //=============== gestion  DP RECU  ================
		  
		  //==================================================
		  
		  // ----------- lecture du payload -------------
		  seq=dis.readLong();
		  repair=dis.readInt();
		  
		  

		  	
		  	//****************** gestion TL **********************
                	
  
                	// test si	on a recu un paquet manquant
   			if (seq<=LastReceive) { 
                		if (seq==LastOrdered+1 ) { 
  					  if (DBG) System.out.println (" 1er DP manquant recu : "
  						+seq+" on supprime le 1er elmt de TL : ");
                				TL.removeFirst();
                			LastOrdered=seq;
                			// -------- on stoppe le timer correspondant ----------
                			
                			
                			timerThread =(TimerMCast) HashTimer.get((seq)+"");
                			//System.out.println("timer alive="+timerThread.isAlive());
                			if (timerThread.isAlive()) {
                					if (DBG) System.out.println("timer alive, on le detruit");
                				    timerThread.Stopper();
                			}
                			
                			HashTimer.remove(""+seq);// on supprime l'entre dans hashtimer
                			// --------------------------------------------------------
                				
                				
                			while (TL.size()>0 && TL.getFirst()=="0") {
  						
                				TL.removeFirst();
                				LastOrdered++;
                			} //while                		
                		
                		} else if (seq>LastOrdered && TL.contains(seq+"")){
                		
 					if (DBG) System.out.println("recu DP manquant ("+seq+") on le met a sa place dans la TL : "+(seq-LastOrdered));
                			TL.add((int)(seq-LastOrdered),"0") ;
                				
                				
                			// -------- on stoppe le timer correspondant ----------
               				
                			timerThread =(TimerMCast) HashTimer.get((seq)+"");
                			
                			if (timerThread.isAlive()) {
                				timerThread.Stopper();
                			}
                			HashTimer.remove(""+seq);// on supprime l'entre dans hashtimer
                			// --------------------------------------------------------
                				
                		} else {
                			 if (DBG) System.out.println(" DP ("+seq+") deja recu, on l'ignore");
                			 
                		} 
                	} else {
                		// la TL n'est pas vide : il manque au - 1 paquet
         			// on ajoute un nouveau DP dans la TL 
         			//et eventuellement des timers sur le DP manquant
         			if (LastReceive==LastOrdered && LastOrdered+1==seq) {
         				//System.out.println("DP recu, aucune perte en vu");
         				LastReceive=seq;
         				LastOrdered=seq;
         			} else {
 				while ((LastReceive+1)!=seq) {
 					//if (DBG) System.out.println("ajout d'1 timer sur le DP "+(LastReceive+1));
 						TL.add("1") ;
				

				
 						//---------- ajout de timer -----------
 				
 					 	// on choisit un timer different par NAK successif
 					 	//, pour viter qu'ils expirent tous en mme temps		
 					 	
 					 	delayTimerDecale= delayTimer+300*(seq-LastOrdered);	
 				
                               TimerMCast timerThread = new TimerMCast(
                                   (LastReceive+1),(int)delayTimerDecale, 
                               	    net,Emetteur, recepteurOriginaire, 
                               	    net.proxyTANId,(int)(firstDelayTL+300*(seq-LastOrdered)));
 					 		
 					 			
						OTimer = (TimerMCast) timerThread;

						
						if (DBG) System.out.println("on rempli la hashtimer "+(LastReceive+1));
						HashTimer.put(""+(LastReceive+1), OTimer);
    						// lancement
    						
    						
  
    						
    						if (!timerThread.isAlive()) {
    					    	//gestion de l'affichage du temps de traitement d'1 timer	
		   					tempsTimerDP = new TimeC().TempsSys();
							timerThread.start();
							//gestion de l'affichage du temps de traitement d'1 timer	
		   					tempsTimerDP=(new TimeC().TempsSys()- tempsTimerDP);
		   					//if (TMP &&tempsTimerDP>0) System.out.println(seq+" DTM "+ tempsTimerDP);
		   					nbboucle=seq;				
						} else {
						   if (DBG) System.out.println(" gestion TL : attention Zombie Timer");
						}
								 
 						//--------------------------------
 					
 						LastReceive++;						
 					}
 					
					// on ajoute un nouveau DP dans la TL 
 					TL.add("0") ;
 					LastReceive++;
 					if (DBG) System.out.println("on note dans TL la reception du DP "+seq);

				}
                	}
                	

		

			
		
			 if (repair==0) { // DP PAS repair 
			 
			 
	
				//=====================================================
			
				// ========== gestion de l'expdition de DP   ==========
			
				//=====================================================		 
			 
			 
		
		  	

		  		//------- calcul du temps d'execution du service pour un DP -----
		   			
		   			tempsGestDP = new TimeC().TempsSys()- temps;
		   			if (tempsGestDP>0) { 
		   			// on supprime de cas o 
		   				MoyenTempsGestDP=
		   					((MoyenTempsGestDP*NbTempsGestDP)+tempsGestDP)/(NbTempsGestDP+1);
		   				NbTempsGestDP++; 
		   				if (TMP) System.out.println(seq+" DP "+tempsGestDP);		     					nbboucle=seq;
		   				
		   				
		   				if (TMP &&tempsTimerDP>0) System.out.println(seq+" DTM "+ (tempsGestDP-tempsTimerDP));
		   				tempsTimerDP=0;
		   				
		  		    	if (MOY && nbMOY==maxNbMOY ){
		  		    		nbMOY=0;
		  		    		System.out.println("dure gestion moyenne pour "+maxNbMOY+" DP="+MoyenTempsGestDP);		
		  		    	}
		  				nbMOY++;
		  			}	
		  		//-------------- traitement multicast -----------------------
		  		
		  		
				for (i=0;i<max_multicast;i++) {

				
			  		if (MulticastArb[i][0].equals(localhost.getHostAddress())) {

		 				net.makeANEPkt( net.serviceNameinBytes, 
							net.srcId.getBytes(), 
							MulticastArb[i][1].getBytes(), 
							MulticastArb[i][1].getBytes(), 
							net.proxyTANId.getBytes(), 
							net.getANEPkt().payload  );
			
			    		if (DBG) System.out.println("emission du DP "+seq+" RECU vers " +MulticastArb[i][1]);
			
						// --------  perte provoque de paquet --------------
						if (jump==max_jump) {
							jump=1;
							max_jump=Math.round((Math.random()*moyennePertePaquet));
							if (DBG) System.out.println("perte du paquet "+seq);
						} else {
							jump=jump+1;
						    net.sendANEPkt_next
							   (InetAddress.getByName(MulticastArb[i][1]));	
						}
			  		} //  fi (MulticastArb[i][0].equals(localhost.getHostAddress()))	

				}// for(i=0;i<max_multicast;i++)


		   


			} else {  // repair = 1
			
				//=====================================================
			
				// ==== gestion de la rxpdition de DP repair =======
			
				//=====================================================
			
			
		  	
				if ( NS.containsKey(Long.toString(seq))){

					//System.out.println("entre dans la NS "+seq+" qui vaut 											//"+NS.get(Long.toString(seq)) );
				
					o =NS.get(Long.toString(seq));
					LL = (LinkedList) o ;
				
				
				
				
				
				    // -------- on stoppe le timer correspondant ----------
                			
                			
                			timerThread =(TimerMCast) HashTimer.get((seq)+"");
                			if (timerThread.isAlive()) {
                				    timerThread.Stopper();
                			}
                			
                			HashTimer.remove(""+seq);// on supprime l'entre dans hashtimer
                			// --------------------------------------------------------
		    		
		    		NS.remove(Long.toString(seq));
		    		//on supprime cette entre de la NS
				
				
			
				    //------- calcul du temps d'execution du service pour un DPR -----
				    
		   			tempsGestDPR = new TimeC().TempsSys()- temps;
		   			if (tempsGestDP>0) { 
		   			// on supprime de cas o on change de seconde		   			
		   			MoyenTempsGestDPR=
		   			((MoyenTempsGestDPR*NbTempsGestDPR)+tempsGestDPR)/(NbTempsGestDPR+1);
		   			NbTempsGestDPR++; 
		   			
		   				if (TMP) System.out.println((nbboucle+1)+" DR "+tempsGestDPR);	
		  		    	if (MOY && nbMOYDPR==maxNbMOYDPR ){
		  		    		nbMOYDPR=0;
		  		    		System.out.println("dure gestion moyenne pour "+maxNbMOYDPR+" DPR="+MoyenTempsGestDPR);		
		  		    	}
		  				nbMOYDPR++;
		  			}	
	
				
				
		  		// -------------- envoi subcast  -----------------------
		  	
				
				
				
				
		    		for (j=0;j<LL.size();j++) {
		    	
					  if (DBG) System.out.println("envoi subcast : REemission DP "+seq+" RECU vers "+LL.get(j));
		    
		    			net.makeANEPkt( net.serviceNameinBytes, 
							net.srcId.getBytes(), 
							((LL.get(j)).toString()).getBytes(), 
							(localhost.getHostAddress()).getBytes(), 
							net.proxyTANId.getBytes(), 
							net.getANEPkt().payload  );
		
						net.sendANEPkt_next(InetAddress.getByName((LL.get(j)).toString()));		 
		    	
		    		}
		    		
		    		
		    		
		    		
		    		

 				} else {
					if (DBG) System.out.println("DPR "+seq+" pas dans NS : envoi gnral");
					
					
					
				    //------- calcul du temps d'execution du service pour un DPR -----
				    
		   			tempsGestDPR = new TimeC().TempsSys()- temps;
		   			if (tempsGestDP>0) { 
		   			// on supprime de cas o on change de seconde		   			
		   			MoyenTempsGestDPR=
		   			((MoyenTempsGestDPR*NbTempsGestDPR)+tempsGestDPR)/(NbTempsGestDPR+1);
		   			NbTempsGestDPR++; 
		   			
		   				if (TMP) System.out.println((nbboucle+1)+" DR "+tempsGestDPR);	
		  		    	if (MOY && nbMOYDPR==maxNbMOYDPR ){
		  		    		nbMOYDPR=0;
		  		    		System.out.println("dure gestion moyenne pour "+maxNbMOYDPR+" DPR="+MoyenTempsGestDPR);		
		  		    	}
		  				nbMOYDPR++;
		  			}	
		   							
					// ----------------envoi multicast --------------------
					for (i=0;i<max_multicast;i++) {
			  			if (MulticastArb[i][0].equals(localhost.getHostAddress())) {

		 					net.makeANEPkt( net.serviceNameinBytes, 
								net.srcId.getBytes(), 
								MulticastArb[i][1].getBytes(), 
								(localhost.getHostAddress()).getBytes(), 
								net.proxyTANId.getBytes(), 
								net.getANEPkt().payload  );
			
			    		if (DBG) System.out.println("rien dans ns : envoi multicast : emission du DPR "+seq+" RECU vers " +MulticastArb[i][1]);	
			    		net.sendANEPkt_next(InetAddress.getByName(MulticastArb[i][1]));	
					
						}			    		
			    	 //---------------- fin  envoi gnral -------------------

					}	
				}
			
			
			
			}	
			

			
		  } else { 
		  // le test sur la taille du payload indique qu'on a trouv un nak
		  
		  
		    
		    	
	  
		    //==================================================
		    
			// ========== gestion des  nak =====================
			
			//==================================================
	    	    
                	seq=dis.readLong();
                
                	// on rcupre l'adress du recepteur qui a
               		RecepteurOriginaireBytes= new byte[12];
                	recepteurOriginaire="";
                	for(int i=0; i<12;i++) 
			{
			
                   	   RecepteurOriginaireBytes[i]=dis.readByte();              								    	  recepteurOriginaire=
                   	   recepteurOriginaire+(char)RecepteurOriginaireBytes[i];
			}
		    
		    
		     
		     if ( (seq>LastOrdered) && (seq<=LastReceive)
		        &&(TL.get((int)(seq-LastOrdered-1))=="1"  )) {
		     
		     // on test si le nak correspond a une entre dans TL :
		     // si c'est le cas, un timer doit dj etre en place
		     // afin de demander  l'emetteur le renvoie du DP 
		     // le cas est dj trait, on ignore ce nak : car 
		     // le DPR sera par dfaut envoy  tous les recepteurs
		      } else {
			//  ========== cration ou maj  NS ================
			
		    // test s'il existe dj cette une entre dans NS
			if ( !NS.containsKey(Long.toString(seq))){
			
			// -------------  cration de NS -------------------
				
				LL.clear();
				
 				LL.addLast(recepteurOriginaire); //ajout recepteur;		
 				NS.put(Long.toString(seq), LL ); //remplissage hastable NS
 				
 				
			// --------  choix d'un R-metteur pour le DP perdu ------------
			
 				DestinataireNak=Emetteur; 
 				
 				
 				// Si l'origine du Nak est le noeud tamanoir pre dans l'arbre 
 				// de multicast, c'est qu'un des rcepteurs de ce noeud a perdu 
 				// le paquet : le noeud tamanoir pre a alors choisi comme replayer
 				// le noeud courant : ce qui signifie que le noeud courant ne lui a
 				// pas envoy de nak, donc qu'il existe au moins un rcepteur ayant
 				// reu le paquet perdu :
 				   
 				// par dfaut, le NAk sera envoy  l'metteur
 				// a moins que l'on trouve un recepteur qui  reu le paquet
 				
 				// donc on va chercher le 1er recepteur qui n'a pas envoy de Nak,
 				// donc qui (peut) avoir recu le paquet perdu ; pour lui
 				// adresser la demande de rxpdition du paquet :
 				
 	
				
 				i=0;
 				while (i<max_multicast) {
			  		if (!(MulticastArb[i][1].equals(recepteurOriginaire) )
			  		   && (MulticastArb[i][0].equals(localhost.getHostAddress()))) {
						
						DestinataireNak=MulticastArb[i][1];
						i=max_multicast; // on force la sortie du while
					} 
				i++ ;
				}
 				
 			// -----------  lancement du timer --------------------				
 				
 				
 				// optimisation : si il n'y a qu'un recepteur et que celui
 				// ci envoi un nak, on le forward sans attendre  l'emetteur, 
 				// sinon :
  				if (!((DestinataireNak).equals(Emetteur))) {
 					TimerMCast timerThread = new TimerMCast
 						(seq,delayTimerNS, net,DestinataireNak, 
 						recepteurOriginaire, net.proxyTANId,firstDelayNS);
					OTimer = (TimerMCast) timerThread;  				
					HashTimer.put(""+seq, OTimer);
    					// lancement
    					
 
    					if (!timerThread.isAlive()) {
    					    	//gestion de l'affichage du temps de traitement d'1 timer	
		   					tempsTimerNK = new TimeC().TempsSys();
							timerThread.start();
							//gestion de l'affichage du temps de traitement d'1 timer	
		   					tempsTimerNK=(new TimeC().TempsSys()- tempsTimerNK);
		   					if (TMP &&tempsTimerNK>0) System.out.println(nbboucle+" NTM "+ tempsTimerNK);	
								
					} else {
							   if (DBG) System.out.println(" gestion TL : attention Zombie Timer");
					}
				} else { //  il n'y a que 1 recepteur, et il n'a pas reu le DP :
				         // on envoi un nak immdiatement (optimisation )
 				
 				
 					TimerMCast timerThread = new TimerMCast
 						(seq,delayTimerNS, net,DestinataireNak, 
 						recepteurOriginaire, net.proxyTANId,1);
 				    // le dernier 1 = emmission immdiate
					OTimer = (TimerMCast) timerThread;  				
					HashTimer.put(""+seq, OTimer);
    					// lancement
    					if (!timerThread.isAlive()) {
								timerThread.start();
					} else {
							   if (DBG) System.out.println("attention Zombie Timer");
					}
 				}
 				if (DBG) System.out.println("on cre NS("+seq+")="+NS.get(Long.toString(seq))+" on va initialiser un timer avec comme recepeteur :"+DestinataireNak);
 				

			} else {
		 	// -------------  mise  jour de NS ------------------
		    	//System.out.println(" NS("+seq+")="+NS.get(Long.toString(seq)));
		    	LL.clear();
		    	o =NS.get(Long.toString(seq));// lecture de la liste des recepteurs
				LL = (LinkedList) o ;
				
				if (!LL.contains(recepteurOriginaire)) {
				// test si le recepteur n'est pas deja dans la liste
				
				
		   		LL.addLast(recepteurOriginaire); // ajout d'un recepteur  la liste
		   		NS.remove(Long.toString(seq));  // maj = suppression et 
		   		NS.put(Long.toString(seq), LL ); // recration de l'entre dans la NS
			
			
			    // ---------- mise  jour du timer --------------
				// on vrifie si ce n'est pas le recepteur qui a t choisi
				// pour la rmission du DP perdu qui vient d'envoyer un 
				// avis de non reception (nak) : si c'est le cas, on en 
				// choisi un autre : si on en trouve pas, on envoie immdiatement
				// un nak  l'metteur
				
				timerThread =(TimerMCast) HashTimer.get((seq)+"");
				if (DBG) System.out.println("test si timer Destinataire ("+timerThread.Destinataire()+")=l'emetteur du nak ("+recepteurOriginaire+")");
                			if ((timerThread.Destinataire()).equals(recepteurOriginaire)) {
                				if (DBG) System.out.println("on devrait chercher un nouveau r-metteur");
                				
                				
                				DestinataireNak=Emetteur; 
 						// par dfaut, le NAk sera envoy  l'metteur
 						i=0;
 						
 
		 		   	LL.addLast(recepteurOriginaire);
		 		   	
		 		   	
		 		   	//LL.addLast("140.77.15.119");
		 		   	//LL.addLast("140.77.15.120");
		 		   	//LL.addLast("140.77.15.121");	
		 		   	//LL.addLast("140.77.15.122");
		 		   	//LL.addLast("140.77.15.123");
		 		   	//LL.addLast("140.77.15.124");		 		   	
		 		   	//if (RPY) temps = new TimeC().TempsSys();
		 
		 
		 
		 
		          // --------  choix d'un R-meteur pour le DP perdu ------------		 	
 						while (i<max_multicast) {
			  		    	if ((MulticastArb[i][0].equals(localhost.getHostAddress()))
			  		         && !(LL.contains(MulticastArb[i][1]))   	
			  		         ) {
						
								DestinataireNak=MulticastArb[i][1];
						
								i=max_multicast; // on force la sortie du while
							} 
							i++ ;
						}
						
						
				       // affichage du temps de calcul d'un replier
				       // if (RPY) { System.out.println( new TimeC().TempsSys()- temps );
				
						

						// optimisation : si tous les recepteurs ont perdu le DP
						// on envoie un NAK immdiatement  la source 	
                				if (DestinataireNak.equals(Emetteur)) {
                				
                					if (DBG) System.out.println(" aucun recepteur n'a reu le DP : on envoie un Nak  la source ("+Emetteur+")immediatement");
                					timerThread.Stopper();
                					TimerMCast timerThread = new TimerMCast 
                					   (seq,delayTimerNS, net,DestinataireNak, 
 								recepteurOriginaire, net.proxyTANId,1);
    							// lancement du timer immdiatement : delayTimer=1
    						
    							 
							timerThread.start();
                				} else {
                				if (DBG) System.out.println(" maj du timer : nouvel r-xpediteur lu :"+DestinataireNak);
                				  timerThread.Destinataire( DestinataireNak);
                				}
                			}
				 
				
				} else {
				 if (DBG) System.out.println (seq+ " dj dans NS");
				}
				
			}
			
		
		
		} // fin du else du if sur la prsence du num de paquet
		// dans TL


		
		//------- calcul du temps d'execution du service pour un nak -----
		   			
		   							
		   							
		   							
		 		   	tempsGestNak = new TimeC().TempsSys()- temps;
		   			if (tempsGestNak>0) { 
		   			// on supprime de cas o on change de seconde		   			
		   			MoyenTempsGestNak=
		   			((MoyenTempsGestNak*NbTempsGestNak)+tempsGestNak)/(NbTempsGestNak+1);
		   			NbTempsGestNak++; 
		   			
		   				if (TMP) System.out.println(nbboucle+" NK "+tempsGestNak);		
		  		    	if (MOY && nbMOYNak==maxNbMOYNak ){
		  		    		nbMOYNak=0;
		  		    		System.out.println("dure gestion moyenne pour "+maxNbMOYNak+" Nak="+MoyenTempsGestNak);		
		  		    	}
		  				nbMOYNak++;
		  			}  							
		   							
		   							
		} // fin du else du if sur la taille du payload
		 

                //=========================================================


		recv();
			
	    } // while (infini)
	} catch (IOException e) {
	    System.err.println( "MultiCastS :  " + e );
	}
    }

    public void process()
    {
    }
} // class MultiCastS




