/**
 *  Emission.java : 
 */

import java.net.*;
import java.io.*;
import java.lang.Math;

public class Emission extends Thread
{


    int jump=1;
    int random_max_jump =64000; // un paquet n'est pas envoye tout les random_max_jump /2

    double max_jump=64000 ;  // a remettre en place pour un tirage alatoire des paquets : Math.round((Math.random()*random_max_jump)); 
    
    static final String VERSION = "0.1";

    static final boolean DBG = true;

    static final double INFINITE = 9999999L;
    
    static String serviceName = "MultiCastS"; //default service

    static String serviceBroker = "http://140.77.15.124"; 
    int delay = 750; // default delay (ms) between each sent packet
    int timeout = 2000; // default time out
    static boolean infiniteLoop = true;


    int proxyTANport = 5432; // default port
    int serverPort = 5432;   // default port

    int proto = TANet.UDP; // default protocol is TCP
    String destId = null;
    long seq=0; // numero de sequence du paquet manquant
    int nbrPingPackets = 0;
    String proxyTAN = "";
    
    //  recuperation de l'adresse local
    InetAddress localhost;
    
    
    byte [] srvNameinBytes;
    byte [] srcIdinBytes  ;   
    // byte [] destIdinBytes ;   
    byte [] lastIdinBytes ;   
    byte [] proxyTANIdinBytes;

    int payloadSize = 4*1024; // default payload size (Bytes)
    byte [] payload ;
    String recepteurOriginal = ""; // contient l`ip du recepteur 
    int repair=0;

    TANet net;



    Emission(TANet net,int delay,int payloadSize,int nbrPingPackets, String recepteurOriginal,int repair, String proxyTAN )
    {
    	this.net=net;
    	this.delay=delay;
    	this.payloadSize=payloadSize;
    	this.nbrPingPackets=nbrPingPackets;
    	//this.destId=destId; 
    	this.recepteurOriginal=recepteurOriginal;
    	this.repair=repair;
    	this.proxyTAN=proxyTAN;
 

    	// recuperation de l'adresse locale
    	try {
    			localhost= InetAddress.getLocalHost();
    	} catch (UnknownHostException e) {
			System.err.println( e );
    	}
    }

    public int sendDataPackets()
    {
    
    
    
	// cache and init some data
	
	String sbsn = new String(serviceBroker + "/" + serviceName);
	srvNameinBytes    = sbsn.getBytes();
	srcIdinBytes      = (localhost.getHostAddress()).getBytes();
	//destIdinBytes     = destId.getBytes(); 
	lastIdinBytes     = srcIdinBytes;
	proxyTANIdinBytes = proxyTAN.getBytes(); 
	
	lastIdinBytes     = (localhost.getHostAddress()).getBytes();
	
	//int t_cpt = 0, r_cpt=0, timeout_cpt=0;

	int nbrPP = nbrPingPackets;
	double min = INFINITE , max = 0 ; // min, max round trip time
	
	if(nbrPingPackets != 0) infiniteLoop = false;

	// -------- remplissage du payload -------------
	
	
	
	while(nbrPP > 0 || infiniteLoop ) {
	
	try {

	ByteArrayOutputStream baos = new ByteArrayOutputStream();
	DataOutputStream dos = new DataOutputStream( baos );
	// perte provoque de paquet tout les jump
	

	if (jump==max_jump) {
		jump=1;
		seq=seq+2;
		System.out.println("perte de paquet  !");
		//max_jump=Math.round((Math.random()*random_max_jump));
		
	} else {
		seq=seq+1; // numero de sequence du paquet 
		jump=jump+1;
	}
	
	
 	// on ajoute le numero de sequence  
	dos.writeLong(seq);
		 
	// on ajoute le bit repair
	dos.writeInt(repair);
	
	// on ajoute la date
	dos.writeLong(System.currentTimeMillis());
	
	
	
	// on ajoute les datas 
	for(int i=20; i<payloadSize-20;i++) 
	  {
		dos.writeByte(73);
	  }
	
	
	payload=baos.toByteArray();
	System.out.println("Emission DP "+seq+" vers "+proxyTAN);	  
	} catch (FileNotFoundException e ) { 
	    System.out.println("Emission = " + e ); 
	
	} catch (IOException e ) { 
	    System.err.println("Emission = " + e );
	    System.exit(0);
	}			     
	
	
	    try {
		// remplacer destIdinBytes par proxyTANIdinBytes le 18/02
		net.makeANEPkt( srvNameinBytes, srcIdinBytes, 
				proxyTANIdinBytes, lastIdinBytes, 
				proxyTANIdinBytes, payload );
		//net.sendANEPkt();	    
		net.sendANEPkt_next(InetAddress.getByName(proxyTAN));
		if(!infiniteLoop) nbrPP--;
		if(delay != 0) {
		    try { sleep( delay ); } 
		    catch (InterruptedException e) {
		   }
		}

	    } catch (IOException e) {
		System.err.println( "Emission : recvANEPkt() : " + e );
		//timeout_cpt++;
		if(!infiniteLoop) nbrPP--;
	    }
	} // while()
	return 0;
    } // sendDataPackets()



    public void run()
    {
   
    
    
	sendDataPackets();
	net.close();
	 if(DBG) System.out.println("Emission : run() thread done.");
    } // run()
	

}

