/**
 *  EmissionNak.java : 
 */

import java.net.*;
import java.io.*;

public class EmissionNak extends Thread
{

    static String serviceBroker = "http://140.77.15.124"; 
    final boolean DBG = false;

    String serviceName = "MultiCastS"; //default service
    int timeout = 1000; // default time out



    int proxyTANport = 5432; // default port
    int serverPort = 5432;   // default port

    int proto = TANet.UDP; // default protocol is TCP
    String destId = null;
    long seq=0; // numero de sequence du paquet manquant
    
    String proxyTAN = "";
    String recepteurOriginal= "";

    byte [] srvNameinBytes;
    byte [] srcIdinBytes  ;   
    byte [] destIdinBytes ;   
    byte [] lastIdinBytes ;   
    byte [] proxyTANIdinBytes;

    int payloadSize = 4*1024; // default payload size (Bytes)
    byte [] payload ;
    
    //  recuperation de l'adresse local
    InetAddress localhost;

    static TANet net;

    EmissionNak(TANet net,String destId, String recepteurOriginal, String proxyTAN,long seq )
    {
    	this.net=net;
    	this.destId=destId; 
    	this.proxyTAN=proxyTAN;
    	this.seq=seq;
    
    	// recuperation de l'adresse locale
	try {
    		localhost= InetAddress.getLocalHost();
    	} catch (UnknownHostException e) {
		System.err.println( e );
    	}
    
    } 



    public int sendNakPackets()
    {
    

	try {
		localhost = InetAddress.getLocalHost();    
    	} catch (UnknownHostException e) {
		System.err.println( e );
	}
	
	
	
	
    //System.out.println( " un test sur le passage de parametre :net.srcId="+net.srcId+", net.destId= "+net.destId+" et destination destId="+destId+" localhost="+localhost.getHostAddress());
	// cache and init some data
	String sbsn = new String(serviceBroker + "/" + serviceName);
	srvNameinBytes    = sbsn.getBytes();
	srcIdinBytes      = net.srcId.getBytes();
	destIdinBytes     = destId.getBytes(); 
	lastIdinBytes     = (localhost.getHostAddress()).getBytes();
	proxyTANIdinBytes = proxyTAN.getBytes(); 
	

	// -------- remplissage du payload -------------
	
	
	try {

	ByteArrayOutputStream baos = new ByteArrayOutputStream();
	DataOutputStream dos = new DataOutputStream( baos );
    	try {
    		localhost= InetAddress.getLocalHost();
    	} catch (UnknownHostException e) {
		System.err.println(  e );
    	}
    
    	recepteurOriginal= localhost.getHostAddress(); 
    	// contient l`ip du recepteur en string

	byte [] srcIdinBytes      = recepteurOriginal.getBytes();
	
 	// on ajoute le numero de sequence  
	dos.writeLong(seq);
		 
	// on ajoute l`adresse 
	for(int i=0; i<srcIdinBytes.length;i++) 
	  {
	
	     Marshalling.putByte(baos,srcIdinBytes[i]);
	  }
	
	payload=baos.toByteArray();
	//if (DBG) System.out.println("EmissionNak.java :Emission nak  "+seq+" dest:"+destId+",recepteurOriginal="+recepteurOriginal+ ",en passant par "+proxyTAN);
		  
	} catch (FileNotFoundException e ) { 
	    System.out.println("Emission = " + e ); 
	
	} catch (IOException e ) { 
	    System.err.println("Emission = " + e );
	    System.exit(0);
	}			     
	
	
	    try {
		net.makeANEPkt( srvNameinBytes, srcIdinBytes, 
				destIdinBytes, lastIdinBytes, 
				proxyTANIdinBytes, payload );
		
			    
		net.sendANEPkt_next(InetAddress.getByName(proxyTAN));
	    } catch (IOException e) {
		System.err.println( "Emission : recvANEPkt() : " + e );
	    }
	
	return 0;
    } // sendNakPackets()


    public void run()
    {
	
	sendNakPackets();
	net.close();
	// if(DBG) System.out.println("Emission : run() thread done.");
    } // run()
	

}

