import java.lang.*;
import java.net.*;
import java.io.*;
import java.util.*;
import com.sun.multicast.reliable.transport.um.*;
import com.sun.multicast.util.*;
import com.sun.multicast.reliable.transport.InvalidMulticastAddressException;
import com.sun.multicast.reliable.transport.InvalidTransportProfileException;
import com.sun.multicast.reliable.transport.RMStatistics;

public class Unicast_Recv extends Thread {
    Multicast_Recv MR;
    StreamStruct stream;
    File f;
    DatagramSocket ds;
    static byte [] srvNameinBytes;
    static byte [] srcIdinBytes ;
    String srcId;
    String desId;
    TANet net;
    long file_size;
    Unicast_Sender usend;
    Timers_Thread nackCheker=null;
    final static Hashtable LS = new Hashtable();// C la table des liens descendants (Links Structure)
    LOClient loclient;
    int Session_End=0;
    Repair_Recv repair_recv;

    public Unicast_Recv (Multicast_Recv MR,StreamStruct stream) throws UnknownHostException, SocketException
    { 
      this.stream = stream;
      this.loclient = new LOClient();
      
      if (!stream.sender)
      {this.MR = MR;
       this.repair_recv = new Repair_Recv(this.MR);
      }
      
      
      this.f = stream.f;
      String serviceName = "MulticastS"; // Nom  du Sercive Multicast
      String serviceBrocker = "http://140.77.15.124";
      String sbsn = new String (serviceBrocker + "/" + serviceName);
      this.srvNameinBytes = sbsn.getBytes();
      
      InetAddress localhost;
      localhost = InetAddress.getLocalHost();
      this.srcId = localhost.getHostAddress();
      this.srcIdinBytes = srcId.getBytes();
      
      this.ds = new DatagramSocket(5000);
      this.net = new TANet ();
      this.usend= new Unicast_Sender();
     
      if (!stream.sender)
      this.nackCheker = new Timers_Thread (usend,stream);

    }

    public void start ()
    {  
       if(!stream.sender)
       {nackCheker.start();
       repair_recv.start();
       }
       super.start();
     }


    

   
    public void nackPktHandler (long seq) throws IOException, UnknownHostException
    {   
	ANEPacket anepkt=null;
       
	byte [] payload ;
	byte [] dat=new byte [1000];;
	DCacheControl pkt;
        int type = 0;
        int repair=1;
	int bytesread;
        long maxseq=0;
	long rate=0;
	file_size=f.length();
	long x = (long) file_size/1000;

	if (seq <= x)
	{  bytesread = 1000;
	   /*else
	       bytesread = (int) (file_size - (x*1000));*/

	  
	
	if (seq<stream.minseq)
	 { 
	    FileInputStream in = new FileInputStream(f);
	    long current = 1000*(seq-1);
	    in.skip(current);
	    in.read(dat,0,1000);
	    maxseq = stream.maxseq;
	  
	    ByteArrayOutputStream baos = new ByteArrayOutputStream ();
	    DataOutputStream dos = new DataOutputStream (baos);
	    repair=1;
	    dos.writeInt(type);
	    dos.writeInt(repair);
	    dos.writeLong(seq);
	    dos.writeLong(maxseq);
	    dos.writeLong(rate);
	    dos.writeInt(bytesread);
	    dos.writeLong(file_size);
   
	    for (int i=44;i<(bytesread+44);i++)
		dos.write(80);
	  
	    payload=baos.toByteArray();
	  
	    for (int k=0; k<bytesread; k++ )
	      payload[k+44]= dat[k];
	       
	    net.makeANEPkt(srvNameinBytes,srcIdinBytes,srcIdinBytes,
						    srcIdinBytes,srcIdinBytes,payload);
	    anepkt=net.anepkt;

	 }
	else
	   { for (int i=0; i<stream.dcache.size();i++)
	      { pkt =  (DCacheControl) stream.dcache.elementAt(i);

	        if (pkt.seq==seq)
	        
		{ anepkt=pkt.anepkt;
		  break;
	        }

	      }

	     
	     if (anepkt==null)
	       System.out.println("Le paquet "+seq+" n'est pas dans le cache");
	     else
	     { ByteArrayInputStream bais = new ByteArrayInputStream(anepkt.payload);
	       DataInputStream dis = new DataInputStream( bais );

	       type=dis.readInt();
	       repair=dis.readInt();
	       seq=dis.readLong();
	       maxseq = dis.readLong();
	       rate = dis.readLong();
	       bytesread=dis.readInt();
	       file_size=dis.readLong();

	       ByteArrayOutputStream baos = new ByteArrayOutputStream ();
	       DataOutputStream dos = new DataOutputStream (baos);

	       repair=1;
	       dos.writeInt(type);
	       dos.writeInt(repair);
	       dos.writeLong(seq);
	       dos.writeLong(maxseq);
	       dos.writeLong(rate);
	       dos.writeInt(bytesread);
	       dos.writeLong(file_size);
	     
	       for (int i=44;i<(bytesread+44);i++)
		   dos.write(80);
		
	       payload=baos.toByteArray();

	       for (int k=0; k<bytesread; k++ )
	       payload[k+44]= anepkt.payload[k+44];
	    
	       net.makeANEPkt(srvNameinBytes,srcIdinBytes,srcIdinBytes,
						    srcIdinBytes,srcIdinBytes,payload);
	       anepkt= net.anepkt;
	       System.out.println("Le paquet "+seq+" est renvoye a partir du cache");
	      }
	    }
        
	/*InetAddress dest_addr = InetAddress.getByName (this.desId);
        byte[] buffer ;
        buffer = anepkt.marshall();
	DatagramPacket dp= new DatagramPacket (buffer,buffer.length,dest_addr,5001);
	DatagramSocket ds= new DatagramSocket();
	ds.send(dp);*/
	
	 usend.SendRepair(this.desId,anepkt);
	}
      }


    protected void notifyNewLO (long lo) throws IOException  
    {
	NewLOEvent evt = new NewLOEvent(this,lo); 
	NewLOListener listener = (NewLOListener) this.loclient;
        listener.NewLO(evt,stream);
    }



    public void crPktHandler(ANEPacket anepkt) throws IOException
    {
     byte [] buffer = anepkt.marshall();
     ByteArrayInputStream bais = new ByteArrayInputStream(anepkt.payload);
     DataInputStream dis = new DataInputStream( bais );
     int type = dis.readInt();
     long lo  = dis.readLong();
     long lr  = dis.readLong();
     long maxseq = dis.readLong();
     
     
     if (lo>stream.lo)
	 {//System.out.println("Le LO a change lo="+lo);
	  stream.lo=lo;
	  notifyNewLO(lo);
	 }

    }

    public void repairPktHandler (ANEPacket anepkt) throws IOException, BadANEPversionException
    {
     byte [] buffer = anepkt.marshall();
     ByteArrayInputStream bais = new ByteArrayInputStream(anepkt.payload);
     DataInputStream dis = new DataInputStream( bais );
     int type = dis.readInt();
     int repair=dis.readInt();
     long seq=dis.readLong();
     long maxseq = dis.readLong();
     long rate = dis.readLong();
     int bytesread=dis.readInt();
     long fle_size=dis.readLong();
     MR.dataPktHandler(anepkt);
     TANet net = new TANet();
     net.anepkt= anepkt;
     net.recoverInfoFromANEPkt();
     
     //System.out.println(" Repair packet "+seq+" is received from "+net.srcId);
     
    }


    
    /*Traitement des paquets Init_Resp recues */

    public void Init_RespPktHandler (ANEPacket anepkt) throws IOException
    {
      TANet net = new TANet();
      net.anepkt=anepkt;
      net.recoverInfoFromANEPkt ();
      //System.out.println("J'ai un noeud fils "+net.srcId);
      
      if (!LS.containsKey(net.srcId)) /*C un nouveau noeud on le met dans Link List*/
	  { LrLo lrlo = new LrLo ();
	    LS.put(net.srcId, lrlo );
	  }

      
     }

    

    public void Session_End (ANEPacket anepkt) throws IOException
    { 
      stream.Session_End=1;
    }

   

 
    public void run () {

	byte[] buffer = new byte [140];
	DatagramPacket dp = new DatagramPacket (buffer, buffer.length);
	ANEPacket anepkt=null;
	
	int type;
	long seq;
	long lo = 0 ;
	long maxseq = 0;
	long rate = 0;
	int repair ;
	FileInputStream in = null;
	byte [] dat=new byte [1000];
	int bytesread = 0 ;
	long file_size;
	int payloadSize = 4*1024;
	byte [] payload ;
	byte [] buffer2  ;
	
	file_size = f.length();
	
	while ((this.isAlive())&&(stream.Session_End==0))
	       { 
	       
	         try{ ds.receive(dp);
		      anepkt=ANEPacket.unmarshall(dp.getData());
		      ByteArrayInputStream bais = new ByteArrayInputStream(anepkt.payload);
		      DataInputStream dis = new DataInputStream( bais );
		      type = dis.readInt();
		      net.anepkt=anepkt;
		      net.recoverInfoFromANEPkt ();
		      this.desId=net.srcId;

		      if (type==0)
		      repairPktHandler(anepkt);
			   
		      if (type==1) 
		          {  seq=dis.readLong();
		             lo =dis.readLong();
			     System.out.println("NACK ("+seq+") from "+net.srcId);
		             nackPktHandler(seq);
			  }

		      if (type==2)
		      crPktHandler(anepkt);
		      

		      if (type==3)
		      Init_RespPktHandler (anepkt);
		       
		      
		      if (type==4)
		      Session_End (anepkt);
		     
		      
		    }catch (IOException e) {System.out.println (e);
	              }catch (BadANEPversionException e) {System.out.println (e);}
		      
	      }

	if(!stream.sender)
	stream.Unicast_End=1;

	System.out.println("Unicast_Recv est fini");

	/*if(!stream.sender)
	{ repair_recv.stop();
	  nackCheker.stop();
	  }*/
    }


    




}








