import java.io.*;
import java.net.*;
import java.lang.*;
import java.util.*;

class RecoitUDP 
{
    static final int MAX_SIZE = 4000;
    static byte[] payload = new byte[MAX_SIZE];
    static int port   = 4000; //12345;
    static String interfaceName = null;
    static DatagramSocket ds;
    DatagramSocket ds2= new DatagramSocket ();
    int type;
    long seq;
    TANet net;
    ActiveSend as ;
    String Multicast_Address = null;

    RecoitUDP(String interfaceName) throws IOException, BadANEPversionException 

    {

	InetAddress ia = null;
	as = null;
	this.interfaceName = interfaceName;
	net = new TANet ();
	as = new ActiveSend();

	try {
            if(interfaceName == null)
                ds = new DatagramSocket( port );
            else {
                ia = InetAddress.getByName(interfaceName);
                ds = new DatagramSocket( port, ia );
            }
	    
	
	    System.out.println("Wait message on " + ia +"/"+port);
	    for(;;) {
		
		DatagramPacket dp = new DatagramPacket (payload, MAX_SIZE);
		ANEPacket anepkt;
		ds.receive (dp);
		byte [] buffer = dp.getData();
		int size = dp.getLength();
		//System.out.println("size="+size);
		byte [] buffer2= new byte [4000];
		
		for (int i=4;i<size;i++)
		buffer2 [i-4]=buffer[i];
		//System.out.println("Bonjour");
		anepkt=ANEPacket.unmarshall(buffer2);
		net.recoverInfoFromANEPkt (anepkt);
		
		if (Multicast_Address==null)
		{ Multicast_Address = net.destId;
		  as.init_socket(Multicast_Address,4000);
		}
		
		ByteArrayInputStream bais = new ByteArrayInputStream(anepkt.payload);
		DataInputStream dis = new DataInputStream( bais );
		type = dis.readInt();
		
		
		if (type==0)
		{seq=dis.readLong();
		 System.out.println("reception du paquet "+seq+" re-emis vers ->"+net.destId);
		 as.write(buffer,size);
		}

		 if (type==3)
		 { 
		   System.out.println("la session est initialise");
		   Init_Resp (net.srcId);
		 }

		/*System.out.println(
				   "ip source = " + dp.getAddress() + "/" + dp.getPort() 
				   + "\n"+
				   //"ip dest   = " + + +
				   "size = " +dp.getLength()
				   );
				   System.out.println("Le message : " + new String(dp.getData()));*/
	    }
        } catch (BindException e) {
            System.err.println( "1 " + e );
            System.exit(1);
        }catch (IOException e) {
            System.err.println( "2 " + e );
        }
    }


    public void Init_Resp (String recId) throws IOException, BadANEPversionException 
    { 
      byte [] payload ;
      int type = 3;
      ANEPacket anepacket;
    
      InetAddress localhost;
      localhost = InetAddress.getLocalHost();
      String srcId = localhost.getHostAddress();
      byte [] srcIdinBytes = srcId.getBytes ();

      byte [] desIdinBytes = recId.getBytes ();

      String serviceName = "MulticastS"; // Nom  du Sercive Multicast
      String serviceBrocker = "http://140.77.15.124";
      String sbsn = new String (serviceBrocker + "/" + serviceName);
      byte [] srvNameinBytes = sbsn.getBytes();

      ByteArrayOutputStream baos = new ByteArrayOutputStream ();
      DataOutputStream dos = new DataOutputStream (baos);	 
      dos.writeInt(type);
      payload=baos.toByteArray();

      TANet net = new TANet ();
      anepacket = net.makeANEPkt(srvNameinBytes,srcIdinBytes,desIdinBytes,desIdinBytes,desIdinBytes,payload);
    
      byte []  buffer = new byte [4000];
      buffer = anepacket.marshall();

      DatagramPacket dp = new DatagramPacket(buffer,buffer.length,InetAddress.getByName(recId),5000);
      ds2.send(dp);
    }


    public static void main( String [] args ) throws IOException, BadANEPversionException
    {
	if(args.length == 1)
	    new RecoitUDP(args[0]);
	else
	    new RecoitUDP(null);
    }

}
