
#define IP     0
#define ICMP   1
#define IGMP   2
#define TCP    6
#define EGP    8
#define UDP   17
#define PIM  103

/* port source d'un paquet TCP */
#define TCP_SPORT(p)    (((Octet)(p))[0] * 256 + ((Octet)(p))[1])     
/* port dest d'un paquet TCP */
#define TCP_DPORT(p)    (((Octet)(p))[2] * 256 + ((Octet)(p))[3])     

#define SKB_SADDR_IP(p)    ((p)->nh.iph->saddr)   
#define SKB_DADDR_IP(p)    ((p)->nh.iph->daddr)  
#define SKB_PROTOCOL_IP(p) ((p)->nh.iph->protocol)
#define SKB_CHECK_IP(p)    ((p)->nh.iph->check)

/* taille d'en-tete d'un paquet IP */
#define SKB_LEN_IP(p)      (((p)->nh.iph->ihl) << 2) 
/* pointeur sur le paquet IP */
#define SKB_HEAD_IP(p)     ((struct iphdr * )((p)->data)) 
